( // Code by olus2000 (UID: 339009650592710656)

FALSE VALUE ENABLE-BUG

BEGIN-STRUCTURE grid
  FIELD: grid.addr
  FIELD: grid.width
  FIELD: grid.height
END-STRUCTURE

BEGIN-STRUCTURE grid-cell
  CFIELD: grid-cell.type
  CFIELD: grid-cell.wseen
  CFIELD: grid-cell.rseen
  CFIELD: grid-cell.invert
END-STRUCTURE

0 CONSTANT GRID-0
1 CONSTANT GRID-/
2 CONSTANT GRID-\
3 CONSTANT GRID-+

CREATE NULL-GRID-CELL grid-cell ALLOT
GRID-0 NULL-GRID-CELL grid-cell.type C!
FALSE NULL-GRID-CELL grid-cell.wseen C!
FALSE NULL-GRID-CELL grid-cell.rseen C!

: grid[] ( n n grid -- grid-cell )
  >R 2DUP 2DUP
  0< 0= SWAP 0< 0= AND SWAP
  R@ grid.height @ < AND SWAP
  R@ grid.width @ < AND 0= R> SWAP
  IF DROP 2DROP NULL-GRID-CELL EXIT THEN
  >R R@ grid.width @ * + grid-cell *
  R> grid.addr @ + ;

10 CONSTANT CHAR-LF

0 VALUE PARSED-GRID
0 VALUE PARSED-STR-ADDR
0 VALUE PARSED-STR-LEN
0 VALUE PARSED-WIDTH
0 VALUE PARSED-HEIGHT
0 VALUE PARSED-MINX
0 VALUE PARSED-MINY

: PARSED-GRID-CELL-TYPE! ( char -- )
  PARSED-WIDTH PARSED-MINX -
  PARSED-HEIGHT PARSED-MINY -
  PARSED-GRID grid[] DUP
  NULL-GRID-CELL = IF 1 ABORT" BONDAGE" THEN
  grid-cell.type C! ;

: ENSURE-UNCHARA ( char -- char )
  DUP CASE
    CHAR-LF OF ENDOF [CHAR] / OF ENDOF
    [CHAR] \ OF ENDOF [CHAR] + OF ENDOF
    BL OF ENDOF 1 ABORT" CHARA"
  ENDCASE ;

: PARSE-GRID ( c-addr u grid -- )
  TO PARSED-GRID TO PARSED-STR-LEN TO PARSED-STR-ADDR
  0 PARSED-GRID grid.height !
  0 PARSED-GRID grid.width !
  0 TO PARSED-WIDTH
  0 TO PARSED-HEIGHT
  PARSED-STR-LEN 0 ?DO
    PARSED-STR-ADDR I CHARS + C@ ENSURE-UNCHARA CASE
      CHAR-LF OF 0 TO PARSED-WIDTH PARSED-HEIGHT 1+ TO PARSED-HEIGHT ENDOF
      BL OF PARSED-WIDTH 1+ TO PARSED-WIDTH ENDOF
      PARSED-WIDTH 1+ DUP TO PARSED-WIDTH
      PARSED-GRID grid.width @ MAX PARSED-GRID grid.width !
      PARSED-HEIGHT 1+ PARSED-GRID grid.height @ MAX PARSED-GRID grid.height !
    ENDCASE
  LOOP
  PARSED-WIDTH TO PARSED-MINX
  PARSED-HEIGHT TO PARSED-MINY
  PARSED-GRID grid.width @ PARSED-GRID grid.height @ 2DROP
  0 TO PARSED-WIDTH
  0 TO PARSED-HEIGHT
  PARSED-STR-LEN 0 ?DO
    PARSED-STR-ADDR I CHARS + C@ CASE
      CHAR-LF OF 0 TO PARSED-WIDTH PARSED-HEIGHT 1+ TO PARSED-HEIGHT ENDOF
      BL OF PARSED-WIDTH 1+ TO PARSED-WIDTH ENDOF
      PARSED-WIDTH PARSED-HEIGHT PARSED-MINX PARSED-MINY 2DROP 2DROP
      PARSED-WIDTH PARSED-MINX MIN TO PARSED-MINX
      PARSED-HEIGHT PARSED-MINY MIN TO PARSED-MINY
      PARSED-WIDTH 1+ TO PARSED-WIDTH
    ENDCASE
  LOOP
  PARSED-MINX NEGATE PARSED-GRID grid.width +!
  PARSED-MINY NEGATE PARSED-GRID grid.height +!
  0 TO PARSED-WIDTH
  0 TO PARSED-HEIGHT
  ALIGN HERE
  PARSED-GRID grid.height @
  PARSED-GRID grid.width @ * >R
  R@ grid-cell * ALLOT
  PARSED-GRID grid.addr !
  R> 0 ?DO
    PARSED-GRID grid.addr @ I grid-cell * + >R
    GRID-0 R@ grid-cell.type C!
    FALSE R@ grid-cell.wseen C!
    FALSE R@ grid-cell.rseen C!
    2 R> grid-cell.invert C!
  LOOP
  PARSED-STR-LEN 0 ?DO
    PARSED-STR-ADDR I CHARS + C@ ENSURE-UNCHARA CASE
      CHAR-LF OF
        0 TO PARSED-WIDTH PARSED-HEIGHT 1+ TO PARSED-HEIGHT FALSE
      ENDOF
      [CHAR] / OF GRID-/ PARSED-GRID-CELL-TYPE! TRUE ENDOF
      [CHAR] \ OF GRID-\ PARSED-GRID-CELL-TYPE! TRUE ENDOF
      [CHAR] + OF GRID-+ PARSED-GRID-CELL-TYPE! TRUE ENDOF
      TRUE
    ENDCASE IF PARSED-WIDTH 1+ TO PARSED-WIDTH THEN
  LOOP ;

BEGIN-STRUCTURE point
  FIELD: point.x
  FIELD: point.y
END-STRUCTURE

CREATE POINT-ZERO point ALLOT 0 0 POINT-ZERO 2!

BEGIN-STRUCTURE grid-cell-def
  point +FIELD grid-cell-def.begin-white-up
  point +FIELD grid-cell-def.begin-white-down
  point +FIELD grid-cell-def.begin-red-up
  point +FIELD grid-cell-def.begin-red-down
  point +FIELD grid-cell-def[0,1]
  point +FIELD grid-cell-def[1,0]
  point +FIELD grid-cell-def[0,-1]
  point +FIELD grid-cell-def[-1,0]
END-STRUCTURE

BEGIN-STRUCTURE grid-cell-defs-t
  grid-cell-def +FIELD grid-cell-defs./
  grid-cell-def +FIELD grid-cell-defs.\
  grid-cell-def +FIELD grid-cell-defs.+
END-STRUCTURE

CREATE GRID-CELL-DEFS grid-cell-defs-t ALLOT

: DIR-FLAT ( n n -- u )
  1+ 3 * SWAP 1+ + ;

: grid-cell-def[] ( n n grid-cell-def -- point )
  >R DIR-FLAT CASE
    0 0 DIR-FLAT OF 0 ENDOF
    0 1 DIR-FLAT OF 4 ENDOF
    1 0 DIR-FLAT OF 5 ENDOF
    0 -1 DIR-FLAT OF 6 ENDOF
    -1 0 DIR-FLAT OF 7 ENDOF
    1 THROW
  ENDCASE point * R> + ;

: 4DUP 2>R 2>R 2R@ 2R> 2R@ 2SWAP 2R> ;

: DEFINE-CELL-CONNECTION ( n n n n grid-cell-def -- )
  >R 4DUP NEGATE SWAP NEGATE SWAP 2SWAP R@ grid-cell-def[] 2!
  2SWAP NEGATE SWAP NEGATE SWAP 2SWAP R> grid-cell-def[] 2! ;

0 1 1 0 GRID-CELL-DEFS grid-cell-defs./ DEFINE-CELL-CONNECTION
0 -1 -1 0 GRID-CELL-DEFS grid-cell-defs./ DEFINE-CELL-CONNECTION
0 -1 SWAP GRID-CELL-DEFS grid-cell-defs./ grid-cell-def.begin-white-up 2!
-1 0 SWAP GRID-CELL-DEFS grid-cell-defs./ grid-cell-def.begin-white-down 2!
0 1 SWAP GRID-CELL-DEFS grid-cell-defs./ grid-cell-def.begin-red-up 2!
1 0 SWAP GRID-CELL-DEFS grid-cell-defs./ grid-cell-def.begin-red-down 2!

0 1 -1 0 GRID-CELL-DEFS grid-cell-defs.\ DEFINE-CELL-CONNECTION
0 -1 1 0 GRID-CELL-DEFS grid-cell-defs.\ DEFINE-CELL-CONNECTION
0 -1 SWAP GRID-CELL-DEFS grid-cell-defs.\ grid-cell-def.begin-white-up 2!
1 0 SWAP GRID-CELL-DEFS grid-cell-defs.\ grid-cell-def.begin-white-down 2!
0 1 SWAP GRID-CELL-DEFS grid-cell-defs.\ grid-cell-def.begin-red-up 2!
-1 0 SWAP GRID-CELL-DEFS grid-cell-defs.\ grid-cell-def.begin-red-down 2!

0 1 0 -1 GRID-CELL-DEFS grid-cell-defs.+ DEFINE-CELL-CONNECTION
1 0 -1 0 GRID-CELL-DEFS grid-cell-defs.+ DEFINE-CELL-CONNECTION
0 -1 SWAP GRID-CELL-DEFS grid-cell-defs.+ grid-cell-def.begin-white-up 2!
0 1 SWAP GRID-CELL-DEFS grid-cell-defs.+ grid-cell-def.begin-white-down 2!
-1 0 SWAP GRID-CELL-DEFS grid-cell-defs.+ grid-cell-def.begin-red-up 2!
1 0 SWAP GRID-CELL-DEFS grid-cell-defs.+ grid-cell-def.begin-red-down 2!

: GRID-CELL-DEF-BEGINS ( u grid-cell -- point[2] grid-cell-def )
  >R R@ grid-cell.invert C@ 1 = IF 1 SWAP - THEN
  GRID-CELL-DEFS R> grid-cell.type C@ 1- grid-cell-def * + >R
  point 2* * R@ + R> ;

BEGIN-STRUCTURE traxer-state
  point +FIELD traxer-state.pos
  point +FIELD traxer-state.prev-pos
  CFIELD: traxer-state.go?
  CFIELD: traxer-state.first
  CFIELD: traxer-state.colour
  CFIELD: traxer-state.dir
  CFIELD: traxer-state.bump
  ALIGNED
END-STRUCTURE

CREATE TRAXER-STATES traxer-state 4 * ALLOT

0 TRAXER-STATES traxer-state 0 * + traxer-state.colour C!
0 TRAXER-STATES traxer-state 1 * + traxer-state.colour C!
1 TRAXER-STATES traxer-state 2 * + traxer-state.colour C!
1 TRAXER-STATES traxer-state 3 * + traxer-state.colour C!
0 TRAXER-STATES traxer-state 0 * + traxer-state.dir C!
1 TRAXER-STATES traxer-state 1 * + traxer-state.dir C!
0 TRAXER-STATES traxer-state 2 * + traxer-state.dir C!
1 TRAXER-STATES traxer-state 3 * + traxer-state.dir C!

0 VALUE CURRENT-TRAXER
CREATE TRAXER-OLDPOS point ALLOT
0 VALUE CURRENT-GRID-CELL
0 VALUE CURRENT-GRID-CELL-DEF
0 VALUE CURRENT-GRID-CELL-BEGINS
0 VALUE NEXT-GRID-CELL
0 VALUE NEXT-GRID-CELL-DEF
0 VALUE NEXT-GRID-CELL-BEGINS
0 VALUE FOUND-LOOP

: COLOUR-MISMATCH ( n n -- flag )
  ENABLE-BUG IF
    ."    diff "
    2DUP SWAP . . CR
  THEN
  DIR-FLAT 2 0 DO
    DUP NEXT-GRID-CELL-BEGINS I point * +
    DUP point.x @ SWAP point.y @ DIR-FLAT = IF
      DROP FALSE UNLOOP EXIT
    THEN
  LOOP DROP TRUE ;

: FIND-DIRECTION ( -- )
  2 0 DO
    CURRENT-GRID-CELL-BEGINS I
    CURRENT-TRAXER traxer-state.dir C@ 1 = IF 1 SWAP - THEN
    point * + >R
    CURRENT-TRAXER traxer-state.pos point.x @ R@ point.x @ +
    CURRENT-TRAXER traxer-state.pos point.y @ R> point.y @ +
    2DUP TRAXER-OLDPOS point.y @ =
    SWAP TRAXER-OLDPOS point.x @ =
    AND 0= IF
      CURRENT-TRAXER traxer-state.pos point.y !
      CURRENT-TRAXER traxer-state.pos point.x !
      UNLOOP EXIT
    THEN 2DROP
  LOOP ;

: FORWARD-TRAXER ( traxer-state -- flag )
  TO CURRENT-TRAXER
  CURRENT-TRAXER traxer-state.go? C@ 0= IF FALSE EXIT THEN
  ENABLE-BUG IF
    CR ." >> color "
    CURRENT-TRAXER traxer-state.colour C@ . CR
    ."    dir "
    CURRENT-TRAXER traxer-state.dir C@ . CR
    ."    from "
    CURRENT-TRAXER traxer-state.prev-pos DUP point.y @ SWAP point.x @ . . CR
    ."    at "
    CURRENT-TRAXER traxer-state.pos DUP point.y @ SWAP point.x @ . . CR
  THEN
  CURRENT-TRAXER traxer-state.prev-pos
  TRAXER-OLDPOS point MOVE
  CURRENT-TRAXER traxer-state.pos
  CURRENT-TRAXER traxer-state.prev-pos point MOVE
  CURRENT-TRAXER traxer-state.pos DUP point.x @ SWAP point.y @ PARSED-GRID
  grid[] TO CURRENT-GRID-CELL
  ENABLE-BUG IF
    ."    ( type "
    CURRENT-GRID-CELL grid-cell.type C@ .
    ." inv "
    CURRENT-GRID-CELL grid-cell.invert C@ .
    ." )" CR
  THEN
  CURRENT-GRID-CELL grid-cell.type C@ GRID-0 = IF
    ENABLE-BUG IF
      ."    reject null source " CR
    THEN
    FALSE EXIT
  THEN
  CURRENT-GRID-CELL grid-cell.invert C@ 2 = IF
    0 CURRENT-GRID-CELL grid-cell.invert C!
  THEN
  CURRENT-TRAXER traxer-state.colour C@ CURRENT-GRID-CELL GRID-CELL-DEF-BEGINS
  TO CURRENT-GRID-CELL-DEF TO CURRENT-GRID-CELL-BEGINS
  CURRENT-GRID-CELL-DEF CURRENT-GRID-CELL-BEGINS CURRENT-TRAXER DROP 2DROP
  FIND-DIRECTION
  CURRENT-TRAXER traxer-state.pos DUP point.x @ SWAP point.y @ PARSED-GRID
  grid[] TO NEXT-GRID-CELL
  ENABLE-BUG IF
    ."    to "
    CURRENT-TRAXER traxer-state.pos DUP point.y @ SWAP point.x @ . . CR
    ."    ( type "
    NEXT-GRID-CELL grid-cell.type C@ .
    ." inv "
    NEXT-GRID-CELL grid-cell.invert C@ .
    ." )" CR
  THEN
  CURRENT-GRID-CELL grid-cell.wseen
  CURRENT-TRAXER traxer-state.colour C@ CHARS + C@
  IF
    ENABLE-BUG IF
      ."    reject seen source " CR
    THEN
    FALSE EXIT
  THEN
  CURRENT-TRAXER traxer-state.first C@ 0= IF
    TRUE CURRENT-GRID-CELL grid-cell.wseen
    CURRENT-TRAXER traxer-state.colour C@ CHARS + C!
  THEN
  FALSE CURRENT-TRAXER traxer-state.first C!
  NEXT-GRID-CELL NULL-GRID-CELL = IF
    TRUE CURRENT-TRAXER traxer-state.bump C!
  THEN
  NEXT-GRID-CELL grid-cell.type C@ GRID-0 = IF
    ENABLE-BUG IF
      ."    reject null target " CR
    THEN
    FALSE EXIT
  THEN
  CURRENT-TRAXER traxer-state.colour C@ NEXT-GRID-CELL GRID-CELL-DEF-BEGINS
  TO NEXT-GRID-CELL-DEF TO NEXT-GRID-CELL-BEGINS
  NEXT-GRID-CELL grid-cell.wseen
  CURRENT-TRAXER traxer-state.colour C@ CHARS + C@ IF
    ENABLE-BUG IF
      ."    found loop" CR
    THEN
    TRUE TO FOUND-LOOP
  THEN TRUE ;

BEGIN-STRUCTURE vstack
  FIELD: vstack.addr
  FIELD: vstack.len
END-STRUCTURE

0 VALUE VSTACK-ITEM

: VSTACK-PUSH ( addr vstack -- )
  >R R@ vstack.addr @ R@ vstack.len @
  VSTACK-ITEM * + VSTACK-ITEM MOVE
  1 R> vstack.len +! ;

: VSTACK-POP ( addr vstack -- flag )
  DUP vstack.len @ 0> 0= IF 2DROP FALSE EXIT THEN
  >R -1 R@ vstack.len +!
  R@ vstack.addr @ R> vstack.len @
  VSTACK-ITEM * + SWAP VSTACK-ITEM MOVE TRUE ;

CREATE QUEUE vstack ALLOT

: IMPLODE-POS ( u u -- u )
  PARSED-GRID grid.width @ * + ;

: EXPLODE-POS ( u -- u u )
  PARSED-GRID grid.width @ /MOD ;

BEGIN-STRUCTURE queue-elem-t
  FIELD: queue-elem.pos
END-STRUCTURE

CREATE QUEUE-ELEM queue-elem-t ALLOT

: NORM-PUSH ( n n -- FLAG )
  2DUP IMPLODE-POS QUEUE-ELEM !
  PARSED-GRID grid[] >R
  R@ grid-cell.type C@ GRID-0 =
  R@ grid-cell.wseen C@ 0= 0= OR 0= R> SWAP IF
    grid-cell.wseen TRUE SWAP C!
    QUEUE-ELEM QUEUE VSTACK-PUSH
  ELSE DROP THEN ;

: NORMALIZE ( -- )
  PARSED-GRID DUP grid.height @ SWAP grid.width @ * DUP point *
  ALIGN HERE QUEUE vstack.addr ! queue-elem-t * ALLOT
  0 QUEUE vstack.len !
  queue-elem-t TO VSTACK-ITEM
  DUP 0 ?DO
    I PARSED-GRID grid.width @ /MOD 2DUP
    TO PARSED-HEIGHT TO PARSED-WIDTH
    NORM-PUSH
    ENABLE-BUG IF
      CR ." [ flood fill at "
      PARSED-WIDTH . PARSED-HEIGHT .
      ."  ]" CR
    THEN
    BEGIN
      QUEUE-ELEM QUEUE VSTACK-POP
    WHILE
      QUEUE-ELEM @ EXPLODE-POS 2DUP TO PARSED-HEIGHT TO PARSED-WIDTH
      PARSED-GRID grid[] DUP TO CURRENT-GRID-CELL
      CURRENT-GRID-CELL grid-cell.invert C@ 2 = IF
        0 CURRENT-GRID-CELL grid-cell.invert C!
      THEN
      ENABLE-BUG IF
        CR ." >> pos "
        PARSED-WIDTH PARSED-HEIGHT SWAP . . CR
      THEN
      ENABLE-BUG IF
        ."    ( type "
        CURRENT-GRID-CELL grid-cell.type C@ .
        ." inv "
        CURRENT-GRID-CELL grid-cell.invert C@ .
        ." )" CR
      THEN
      DUP grid-cell.type C@ GRID-0 = IF 0 ELSE 2 THEN 0 ?DO
        ENABLE-BUG IF
          ."    color "
          I . CR
        THEN
        DUP I SWAP GRID-CELL-DEF-BEGINS
        TO CURRENT-GRID-CELL-DEF
        TO CURRENT-GRID-CELL-BEGINS
        2 0 DO
          CURRENT-GRID-CELL-BEGINS I point * + DUP point.x @ SWAP point.y @
          ENABLE-BUG IF
            ."    dir "
            2DUP SWAP . . CR
          THEN
          2DUP PARSED-WIDTH PARSED-HEIGHT ROT + ROT ROT + SWAP 2DUP
          ENABLE-BUG IF
            ."    to "
            2DUP SWAP . . CR
          THEN
          NORM-PUSH PARSED-GRID grid[] DUP
          TO NEXT-GRID-CELL DUP grid-cell.type C@
          ENABLE-BUG IF
            ."    to "
            QUEUE-ELEM @ EXPLODE-POS SWAP . . CR
          THEN
          GRID-0 = IF
            ENABLE-BUG IF
              ."    reject null target " CR
            THEN
            DROP 2DROP
          ELSE
            J SWAP GRID-CELL-DEF-BEGINS
            TO NEXT-GRID-CELL-DEF
            TO NEXT-GRID-CELL-BEGINS
            NEGATE SWAP NEGATE SWAP
            COLOUR-MISMATCH IF
              ENABLE-BUG IF
                ."    inverting " CR
              THEN
              NEXT-GRID-CELL grid-cell.invert C@ 2 = 0= IF
                1 ABORT" VERTIGO"
              THEN
              1 NEXT-GRID-CELL grid-cell.invert C!
            ELSE
              NEXT-GRID-CELL grid-cell.invert C@ 2 = IF
                ENABLE-BUG IF
                  ."    default " CR
                THEN
                0 NEXT-GRID-CELL grid-cell.invert C!
              THEN
            THEN
          THEN
        LOOP
      LOOP DROP
    REPEAT
  LOOP DUP 0 ?DO
    I PARSED-GRID grid.width @ /MOD
    PARSED-GRID grid[]
    grid-cell.wseen FALSE SWAP C!
  LOOP DROP ;

: ANALYZE-GRID ( -- flag )
  PARSED-GRID grid.width @ PARSED-GRID grid.height @ * 0 ?DO
    I PARSED-GRID grid.height @ /MOD
    TO PARSED-HEIGHT TO PARSED-WIDTH
    ENABLE-BUG IF
      CR CR ." [ #" I . ." scanning at "
      PARSED-WIDTH . PARSED-HEIGHT .
      ." ]" CR
    THEN
    4 0 DO
      TRAXER-STATES I traxer-state * + >R
      PARSED-HEIGHT PARSED-WIDTH R@ traxer-state.pos 2!
      R@ traxer-state.pos
      R@ traxer-state.prev-pos point MOVE
      TRUE R@ traxer-state.go? C!
      TRUE R@ traxer-state.first C!
      FALSE R> traxer-state.bump C!
    LOOP
    FALSE TO FOUND-LOOP
    4 0 DO
      TRAXER-STATES I traxer-state * + FORWARD-TRAXER
      TRAXER-STATES I traxer-state * + traxer-state.go? C!
    LOOP
    TRUE CURRENT-GRID-CELL grid-cell.wseen C!
    TRUE CURRENT-GRID-CELL grid-cell.rseen C!
    BEGIN
      FOUND-LOOP 0=
      FALSE 4 0 DO
        TRAXER-STATES I traxer-state * + traxer-state.go? C@ OR
      LOOP AND
    WHILE
      ENABLE-BUG IF CR ." ..." CR THEN
      4 0 DO
        TRAXER-STATES I traxer-state * + FORWARD-TRAXER
        TRAXER-STATES I traxer-state * + traxer-state.go? C!
      LOOP
    REPEAT
    FOUND-LOOP IF
      ENABLE-BUG IF ." loop!" CR THEN FALSE UNLOOP EXIT
    THEN
    2 0 DO
      TRAXER-STATES I 2* 0 + traxer-state * + traxer-state.bump C@
      TRAXER-STATES I 2* 1 + traxer-state * + traxer-state.bump C@
      AND IF
        TRAXER-STATES I 2* 0 + traxer-state * + traxer-state.pos point.x @
        TRAXER-STATES I 2* 1 + traxer-state * + traxer-state.pos point.x @
        - ABS
        TRAXER-STATES I 2* 0 + traxer-state * + traxer-state.pos point.y @
        TRAXER-STATES I 2* 1 + traxer-state * + traxer-state.pos point.y @
        - ABS MAX 8 < 0= IF
          ENABLE-BUG IF ." line!" CR THEN FALSE UNLOOP UNLOOP EXIT
        THEN
      THEN
    LOOP
  LOOP TRUE ;

: ENTRY ( c-addr u -- flag )
  HERE >R ALIGN HERE grid ALLOT PARSE-GRID
  NORMALIZE ANALYZE-GRID
  R> HERE - ENABLE-BUG IF
    CR
    DUP NEGATE . ." bytes used" CR
  THEN ALLOT ;
